#!/usr/bin/perl -w

use strict;
use warnings;

use DBI;

my $dbh = DBI->connect("dbi:monetdb:database=kddart_marker_v2_3_1;host=localhost;port=50000;language=sql", "monetdb", "monetdb");

my $sql;

my $sth;

my $arrayref = [];

for(my $i = 0; $i < 100; $i++) {

	$dbh = DBI->connect("dbi:monetdb:database=kddart_marker_v2_3_1;host=localhost;port=50000;language=sql", "monetdb", "monetdb");

	print "Iteration: $i - start\n";

	$sql    = 'SELECT "analgroupextract"."ExtractId", "analysisgroup"."AnalysisGroupId", ';
	$sql   .= '"analysisgroup"."AnalysisGroupName" ';
	$sql   .= 'FROM "analysisgroup" LEFT JOIN "analgroupextract" ON ';
	$sql   .= '"analysisgroup"."AnalysisGroupId" = "analgroupextract"."AnalysisGroupId" ';
	$sql   .= 'WHERE "analgroupextract"."ExtractId" IN ';
	$sql   .= '(SELECT "ExtractId" FROM "extract")';

	$sth = $dbh->prepare($sql);
	$sth->execute();

	if ($dbh->err()) {

		die "DBH Error: " . $dbh->errstr() . "\n";
	}

	$arrayref = $sth->fetchall_arrayref({});

	if ($sth->err()) {

		die "STH Error: " . $dbh->errstr() . "\n";
	}

	#foreach my $hashref (@{$arrayref}) {

	#	foreach my $field (keys(%{$hashref})) {

	#		my $field_val = $hashref->{$field};
	#		print "$field : $field_val\n";		
	#	}
	#}

	#$sth->finish();

	print "Iteration: $i - finish\n";
	$dbh->disconnect();
}

my $nb_row = scalar(@{$arrayref});

print "Number of rows: $nb_row\n";

